#!/usr/local/bin/perl  
# 
# Don't touch anything else below unless you know what's happenin'

use 5.005; 
use gedail_pack qw(gedail_main gedail_vers process_accents jpegsize bincopy);

#########################
## Drag and drop
#
if (@ARGV) { 
	if ( @ARGV and ( $#ARGV == 0 ) ) {
		if ( $ARGV[0] =~ /(.*)\.(ged|GED)$/ ) {
			$file_ged = $ARGV[0];
			$file_opt = $1 . ".opt";
		}
		elsif ( $ARGV[0] =~ /(.*)\.(opt|OPT)$/ ) { $file_opt = $ARGV[0]; }
		else { usage ("* Filetype error"); }
	}
	elsif ( $#ARGV == 1 ) {
		$file_opt = $ARGV[0];
		if ( $file_opt !~ /(.*)\.(opt|OPT)$/ ) { usage ("* Filetype error"); }
		$file_ged = $ARGV[1];
		if ( $file_ged !~ /(.*)\.(ged|GED)$/ ) { usage ("* Filetype error"); }
	}
	if ($file_ged !~ /^.:[!@#$%^&()_-{}`\'\\\/\sa-zA-Z0-9]*\.ged$/i) { $file_ged = &dos_name($file_ged); }
	if ($file_opt !~ /^.:[!@#$%^&()_-{}`\'\\\/\sa-zA-Z0-9]*\.opt$/i) { $file_opt = &dos_name($file_opt); }
	($ret,$duration,$out_dir) = &gedail_main($file_ged,$file_opt);
	&display_file('result.html');
	exit &ret;
}
# Abort if wrong parameter usage
sub usage {
	my $err=shift;
	die "$err * usage: $0 [option_file.opt][gedcom_file.ged]\n";
}

use Tk 8.0; 
use Tk::widgets qw/Dialog/; 
use Tk::Balloon; 
use Tk::DirTree;
use HTML::Display;

($version,$msg_lang) = gedail_vers();


$prog_name = $0;
$prog_name =~ /^(.*)(\\|\/)gedail(\\|\/)([^\\\/]+?)$/i;
if ($1) { $install_dir = $1; } else { $install_dir =".."; }

#########################
## Libells
#
if ($msg_lang eq 'fr') {
	$V2_file_t = 'Fichier';
	$V2_file_1 = 'Ouvrir';
	$V2_file_2 = 'Quitter';
	$V2_file_3 = 'Proprits';
	$V2_file_4 = 'Derniers rsultats';
	$V2_opts_t = 'Personnaliser';
	$V2_opts_1 = 'Restaurer les options par dfaut';
	$V2_opts_2 = 'Modifier les options';
	$V2_opts_3 = 'Crer un nouveau fichier options';
	$V2_pics_t = 'Photos';
	$V2_pics_1 = 'Regnrer';
	$V2_pics_2 = 'Galerie';
	$V2_help_t = 'Aide';
	$V2_help_1 = 'Version';
	$V2_help_2 = 'A propos';
	$V2_help_3 = 'Documentation';
	$V2_help_4 = 'Site web Gedail';
	$V2_help_5 = 'Forum';
	$V2_mess_1 = 'Selectionner le fichier gedcom  traiter';
	$V2_mess_2 = 'Les options personnelles seront effaces !';
	$V2_mess_3 = 'Selectionnez les options  modifier';
	$V2_mess_4 = 'Pas de fichier gedcom selectionn';
	$V2_mess_5 = 'Nom de gedcom invalide';
	$V2_mess_6 = "$file_opt existe dj";
	$V2_mess_7 = "Selectionner le rpertoire";
	$V2_mess_8 = "n'existe pas";
	$V2_acts_1 = 'Restaurer les options par dfaut';
	$V2_acts_2 = 'Quitter';
	$V2_acts_3 = 'Enregistrer';
	$V2_text_1 = 'A propos de Gedail';
	$V2_text_2 = 'Execution de Gedail sur';
	$V2_text_3 = 'Fichier Gedcom en entre';
	$V2_text_4 = 'Fichier option : ';
	$V2_text_5 = ' erreurs';
	$V2_text_6 = ' sauvegard';
	$V2_text_7 = 'ecrit par'; 
	$V2_text_8 = 'fichiers crs ou mis  jour dans';
	$V2_text_9 = 'manquant';
	$V2_text_10 = 'Ajuster le texte  une largeur de';
	$V2_text_11 = 'caractres ( largeur variable si 0)';
	$V2_text_12 = ' images traites';
	$V2_text_13 = 'Galerie de photos';
	$V2_about = "Gedail : Programme de gnration de site gnalogique\n\nLogiciel gratuit sous licence GPL\n(c) Jean-Franois BAQUET 2000-2005\n\nhttp://www.baquet.org/outils";
	$V2_doc = "$install_dir\\Gedail\\Doc\\fonctions.html";
	$V2_site = 'jfbaquet.free.fr/outils/outils.html';
	$V2_forum = 'groups.google.com/group/Gedail';
	$V2_n_indi = 'Individus';
	$V2_n_fam = 'Familles';
	$V2_n_note = 'Notes';
	$V2_n_sour = 'Sources';
	$V2_n_obje = 'Photos, medias';
	$V2_n_even = 'Evnements et attributs';
	$V2_n_note2 = 'Notes d\'vnements';
	$V2_n_sour2 = 'Sources d\'vnements';
	$V2_n_obje2 = 'Photos, medias d\'vnements';
	$V2_ged_date = 'Cration';
	$V2_ged_format = 'Format';
	$V2_ged_char = 'Jeu de caractres';
	$V2_ged_aut = 'Auteur';
	$V2_ged_addr1 = 'Adresse';
	$V2_ged_addr2 = '';
	$V2_ged_addr3 = '';
	$V2_ged_addr4 = '';
	$V2_ged_ctry = 'Pays';
	$V2_ged_phone = 'Tlphone';
	$V2_ged_email = 'Email';
}
elsif ($msg_lang eq 'nl') {
	$V2_file_t = 'Bestand';
	$V2_file_1 = 'Openen';
	$V2_file_2 = 'Sluiten';
	$V2_file_3 = 'Eigenschappen';
	$V2_file_4 = 'Laatste resultaten';
	$V2_opts_t = 'Personaliseren';
	$V2_opts_1 = 'Default opties opnieuw instellen';
	$V2_opts_2 = 'Opties wijzigen';
	$V2_opts_3 = 'Opties nieuw bestand aanmaken';
	$V2_pics_t = 'Foto\'s';
	$V2_pics_1 = 'Regnrer';
	$V2_pics_2 = 'Galerie';
	$V2_help_t = 'Help';
	$V2_help_1 = 'Versie';
	$V2_help_2 = 'Over';
	$V2_help_3 = 'Documentatie';
	$V2_help_4 = 'Gedail web site';
	$V2_help_5 = 'Forum';
	$V2_mess_1 = 'Te verwerken Gedcom kiezen';
	$V2_mess_2 = 'De persoonlijke opties werden gewist!';
	$V2_mess_3 = 'Te wijzigen opties kiezen';
	$V2_mess_4 = 'Geen Gedcom bestand aangeduid';
	$V2_mess_5 = 'Ongeldige Gedcomnaam';
	$V2_mess_6 = "$file_opt bestaat reeds";
	$V2_mess_7 = "Map kiezen";
	$V2_mess_8 = "bestaat niet";
	$V2_acts_1 = ' Default opties opnieuw instellen';
	$V2_acts_2 = 'Sluiten';
	$V2_acts_3 = 'Beschermen'; # QUE VEUT DIRE  ????  
	$V2_text_1 = 'Over Gedail';
	$V2_text_2 = 'Uitvoering van Gedail voor'; # QUE VEUT DIRE  ????
	$V2_text_3 = 'Gedcom bestand'; # QUE VEUT DIRE   ????
	$V2_text_4 = 'Optie bestand : '; # QUE VEUT DIRE  ????
	$V2_text_5 = ' fouten';
	$V2_text_6 = ' bewaren';
	$V2_text_7 = 'geschreven door'; 
	$V2_text_8 = 'aangemaakte of bijgewerke bestanden in';
	$V2_text_9 = 'ontbreken';
	$V2_text_10 = 'Tekst instellen op een breedte van';
	$V2_text_11 = 'tekens ( variabele breedte indien 0)';
	$V2_text_12 = ' verwerkte beelden';
	$V2_text_13 = 'Foto\'s galerij';
	$V2_about = "Gedail : Programma voor de aanmaak van een genealogische webstek\n\n Gratis Software onder GPL\n(c) Jean-Franois BAQUET 2000-2005\n\nhttp://www.baquet.org/outils";
	$V2_doc = "$install_dir\\Gedail\\Doc\\fonc_en.html";
	$V2_site = 'jfbaquet.free.fr/outils/outi_en.html';
	$V2_forum = 'groups.google.com/group/Gedail';
	$V2_n_indi = 'Personen';
	$V2_n_fam = 'Families';  
	$V2_n_obje = 'Foto\'s, media';
	$V2_n_note = 'Notities';
	$V2_n_sour = 'Bronnen';
	$V2_n_even = 'Gebeurtenissen en kenmerken';
	$V2_n_note2 = 'Notities Gebeurtenissen';
	$V2_n_sour2 = 'Bronnen Gebeurtenissen';
	$V2_n_obje2 = 'Foto\'s, media Gebeurtenissen';
	$V2_ged_date = 'Aanmaak';
	$V2_ged_format = 'Formaat';
	$V2_ged_char = 'Lettertekens';
	$V2_ged_aut = 'Auteur';
	$V2_ged_addr1 = 'Adres';
	$V2_ged_addr2 = '';
	$V2_ged_addr3 = '';
	$V2_ged_addr4 = '';
	$V2_ged_ctry = 'Land';
	$V2_ged_phone = 'Telefoon';
	$V2_ged_email = 'Email';
}
else {
	$V2_file_t = 'File';
	$V2_file_1 = 'Open';
	$V2_file_2 = 'Quit';
	$V2_file_3 = 'Properties';
	$V2_file_4 = 'Last results';
	$V2_opts_t = 'Customize';
	$V2_opts_1 = 'Restore default options';
	$V2_opts_2 = 'Modify options file';
	$V2_opts_3 = 'Create a new options file';
	$V2_pics_t = 'Pictures';
	$V2_pics_1 = 'Generate';
	$V2_pics_2 = 'Gallery';
	$V2_help_t = 'Help';
	$V2_help_1 = 'Version';
	$V2_help_2 = 'About';
	$V2_help_3 = 'Documentation';
	$V2_help_4 = 'Gedail web site';
	$V2_help_5 = 'Forum';
	$V2_mess_1 = 'Select file to be processed';
	$V2_mess_2 = 'Personnal options will be lost !';
	$V2_mess_3 = 'Select options to update';
	$V2_mess_4 = 'No gedcom file selected';
	$V2_mess_5 = 'Invalid gedcom name';
	$V2_mess_6 = "$file_opt already exists";
	$V2_mess_7 = "Select directory";
	$V2_mess_8 = "do not exist";
	$V2_acts_1 = 'Restore the default options';
	$V2_acts_2 = 'Quit';
	$V2_acts_3 = 'Save';
	$V2_text_1 = 'About Gedail';
	$V2_text_2 = 'Executing Gedail on';
	$V2_text_3 = 'Gedcom input file';
	$V2_text_4 = 'Option file : ';
	$V2_text_5 = ' errors';
	$V2_text_6 = ' saved';
	$V2_text_7 = 'Written by';
	$V2_text_8 = 'files created or updated in';
	$V2_text_9 = 'missing';
	$V2_text_10 = 'Adjust text width to';
	$V2_text_11 = 'chars ( variable width if 0)';
	$V2_text_12 = ' pictures processed';
	$V2_text_13 = 'Photos gallery';
	$V2_about = "Gedail : Genealogical site generation software\n\nFreeware under GPL licence\n(c) Jean-Franois BAQUET 2000-2005\n\nhttp://www.baquet.org/outils";
	$V2_doc = "$install_dir\\Gedail\\Doc\\fonc_en.html";
	$V2_site = 'jfbaquet.free.fr/outils/outi_en.html';
	$V2_forum = 'groups.google.com/group/Gedail';
	$V2_n_indi = 'Individuals';
	$V2_n_fam = 'Families';
	$V2_n_obje = 'Pictures, medias';
	$V2_n_note = 'Notes';
	$V2_n_sour = 'Sources';
	$V2_n_even = 'Events and attributes';
	$V2_n_note2 = 'Events notes';
	$V2_n_sour2 = 'Events sources';
	$V2_n_obje2 = 'Events pictures, medias';
	$V2_ged_date = 'Creation';
	$V2_ged_format = 'Format';
	$V2_ged_char = 'Charset';
	$V2_ged_aut = 'Author';
	$V2_ged_addr1 = 'Address';
	$V2_ged_addr2 = '';
	$V2_ged_addr3 = '';
	$V2_ged_addr4 = '';
	$V2_ged_ctry = 'Country';
	$V2_ged_phone = 'Phone';
	$V2_ged_email = 'Email';
}
#########################
## variables
#
@cat_lib = '';		# libell de la catgorie
@cat_icon = '';		# icne de la catgorie 
@cat_lmax = '';		# taille maxi libell de la catgorie   
@line_comm = '';	# commentaire
@line_cat = '';		# catgorie
@line_var = '';		# nom de variable
@line_q1 = '';		# quote 1
@line_value = '';	# valeur
@line_q2 = '';		# quote 2
@line_def = '';		# dfaut
@line_save = '';	# valeur sauvegarde
@line_error = '';	# indicateur d'erreurs
@line_zlen = '';	# longueur
@line_zform = '';	# format
@lang_tab = '';		# langages possibles
@lang_sel = '';		# langages selectionns
$lang_count = 0;	# nombre de langues
$lang_line = 0;		# numro de lignes de langues
%opt_line = '';		# numro de ligne de la variable
$line_count = 0;	# nombre de lignes
$cat_count = 0;		# nombre de catgories
$var_max = 0;		# longueur maximale
$last_check = '';
$file_ged = '';
$file_opt = '';
$ged_dir = '';
$i_save = 0;
@file_save = '';
%edit_txt = '';		# text edited
$text_width = 0;
$out_dir = '';		# output directory
$co_max =0; $ga_max =0;
sub init_var {
# paramtres pour Gedpics
	$i_pics = 0;
	@pics_file = ();
	@pics_title = ();
	@pics_exist = ();
	$pics_dir = '';
	$photo_max_size = '640x480';
	$photo_thumb_size = '56x42';
	$photo_gallery = '10x5';
} # end init_var

if (open( SAV_FILE, "gedisave.txt" )) {
	while (<SAV_FILE>) {
		chomp;
		$file_save = $_;
		if ( -e "$file_save" ) { 
			$file_save[$i_save] = $file_save; 
			$i_save++;
		}
	}
	close SAV_FILE ;
}

#########################
## Creating main window
#

$mw = MainWindow->new;

$t16 = $mw->fontCreate(-family => "times", -size => 16);
$t16i = $mw->fontCreate(-family => "times", -size => 16, -slant => "italic");
$h24b = $mw->fontCreate(-family => "helvetica", -size => 24, -weight => "bold");
$h12b = $mw->fontCreate(-family => "helvetica", -size => 12, -weight => "bold");
$h12i = $mw->fontCreate(-family => "helvetica", -size => 12, -slant => "italic");

$mw->title("Gedail"); 
$mw->iconname('gedail'); 
my $xpm = $mw->Photo(-file => "gedail.bmp", -format => 'bmp'); 
$mw->Icon(-image => $xpm);       # full color icon picture 
$mw->Label(-text => "Version $version - $V2_text_7 J-F BAQUET <mail\@baquet.org>", -relief => 'sunken')->pack(-side => 'bottom',  -fill => 'both');
$mess_area = $mw->Label(-text =>$V2_mess_1, -height => '1', -width => '140', -background => 'white', -relief => 'flat')->pack(-side => 'bottom', -expand => '1', -fill => 'both');

my $lookup_frame = $mw->Frame()->pack(-fill => 'both', -side => 'top', );
$lookup_frame->Label(-text => "Gedcom : ")->pack(-side => 'left');
my $lookup_file = $lookup_frame->Entry(-textvariable => \$file_ged, -width => '80', -relief => 'sunken')->pack(-side => 'left', -expand => '1', -fill => 'x');

my $exec = $lookup_frame->Button(-text => 'Go', -background => 'red', -foreground => 'yellow', -command => sub { &go_gedail(\$file_ged) });
$exec->pack(-side => 'left', -fill => 'both');


######################
## Creating menu bar
#

my $menubar = $mw->Menu; 
$mw->configure(-menu => $menubar); 
my $file = $menubar->cascade(-label => "~$V2_file_t", -tearoff => 0); 
my $opts = $menubar->cascade(-label => "~$V2_opts_t", -tearoff => 0); 
my $pics = '';
if (($^O eq 'MSWin32') and ( -e "$install_dir\\Gedpics\\VisualMagick\\bin\\convert.exe" )) { 
	$pics = $menubar->cascade(-label => "~$V2_pics_t", -tearoff => 0);
}
my $help = $menubar->cascade(-label => "~$V2_help_t", -tearoff => 0); 

# Create the File menu items. 

$file->command(-label => "$V2_file_1", -command => sub { $file_ged = &browse_file; &find_options; });
if ($file_save[0]) { $file->command(-label => "$file_save[0]", -command => sub { $file_ged = $file_save[0]; &find_options; } ); }
if ($file_save[1]) { $file->command(-label => "$file_save[1]", -command => sub { $file_ged = $file_save[1]; &find_options; } ); }
if ($file_save[2]) { $file->command(-label => "$file_save[2]", -command => sub { $file_ged = $file_save[2]; &find_options; } ); }
if ($file_save[3]) { $file->command(-label => "$file_save[3]", -command => sub { $file_ged = $file_save[3]; &find_options; } ); }
if ($file_save[4]) { $file->command(-label => "$file_save[4]", -command => sub { $file_ged = $file_save[4]; &find_options; } ); }
$file->separator; 
$file->command(-label => "$V2_file_3", -command => \&ana_ged); 
$file->command(-label => "$V2_file_4", -command => [\&display_file, 'result.html']); 
$file->command(-label => "$V2_file_2", -command => \&fini); 

# Create the Option menu items. 

$opts->command(-label => "$V2_opts_1"); 
$opts->command(-label => "$V2_opts_2"); 
$opts->command(-label => "$V2_opts_3"); 
my $menu = $opts->cget('-menu'); 
$menu->entryconfigure("$V2_opts_1", -command => \&restore_default_options); 
$menu->entryconfigure("$V2_opts_2", -command => \&customize_options); 
$menu->entryconfigure("$V2_opts_3", -command => \&new_options_file); 

# Create the Pictures menu items. 

if (($^O eq 'MSWin32') and ( -e "$install_dir\\Gedpics\\VisualMagick\\bin\\convert.exe" )) { 
	$pics->command(-label => "$V2_pics_1"); 
	$pics->command(-label => "$V2_pics_2"); 
	$menu = $pics->cget('-menu'); 
	$menu->entryconfigure("$V2_pics_1", -command => sub { &pics_generate(\$file_ged) }); 
	$menu->entryconfigure("$V2_pics_2", -command => [\&display_file, "$install_dir\\Gedpics\\gedpicst.html"]); 
}

# Create the Help menu items. 

$help->command(-label => "$V2_help_3"); 
$help->separator; 
$help->command(-label => "$V2_help_4"); 
$help->command(-label => "$V2_help_5"); 
$help->separator; 
$help->command(-label => "$V2_help_1"); 
$help->command(-label => "$V2_help_2"); 

$menu = $help->cget('-menu'); 
$menu->entryconfigure("$V2_help_1", -command => \&help1); 
$menu->entryconfigure("$V2_help_2", -command => \&help2); 
$menu->entryconfigure("$V2_help_3", -command => [\&display_file, $V2_doc]); 
$menu->entryconfigure("$V2_help_4", -command => [\&display_html, $V2_site]); 
$menu->entryconfigure("$V2_help_5", -command => [\&display_html, $V2_forum]); 

$mw->focus;

MainLoop; 

sub fini { 
    exit; 
} # end fini 

sub mess_print { 
    my $mess_txt = shift;
 	$mess_area->configure(-text =>$mess_txt );
} # end mess_print 

sub restore_default_options {
	if ($file_ged) {
		my $def_window = $mw->Toplevel(-title   => "$V2_opts_t : $V2_opts_1");
		$def_window->Label(-bitmap => 'warning')->pack(-side => 'left');
		$def_window->Label(-text => "$V2_mess_2")->pack;
		$def_window->Button(-text => "$V2_acts_1", -command => sub { &restore_default; $ret=&save_options('0'); if (!$ret) {$def_window->destroy;} } )
			->pack;
		$def_window->Button(-text => "$V2_acts_2", -command => sub { $def_window->destroy } )
			->pack;
		$def_window->focus;						
	}
	else {
		alert("$V2_mess_4");
	}

} # end restore_default_options

sub customize_options {
	if ($file_ged) {
		my $i = 0;
		if($ga_max) { 
			for ($i=0;$i<$ga_max;$i++) { $ga_w[$i]->destroy; } 
			$mw->update; 
			$ga_max =0; 
		}
		if(!$co_max) { 
			my @img = '';
			for ($i=1;$i<=$cat_count;$i++) {
				$img[$i] = $mw->Photo(-file => "$cat_icon[$i]", -format => 'bmp');
			}
			$co_w[0] = $mw->Frame()->pack(-anchor => 'nw');
			$co_w[0]->Label(-text => ' ')->pack(-side => 'left');
			$co_max = 1;
			for (my $i=1;$i<=$cat_count;$i++) {
				$co_w[$i] = $mw->Frame()->pack(-anchor => 'nw'); $co_max++;
				$co_w[$i]->Label(-text => ' ')->pack(-side => 'left', -ipadx => '10', -anchor => 'nw');
				$co_w[$i]->Button(-image => $img[$i], -command => [\&select_options, $i])->pack(-side => 'left');
				$co_w[$i]->Label(-text => ' ')->pack(-side => 'left', -ipadx => '10');
				$co_w[$i]->Label(-text => $cat_lib[$i], -font => $t16i)->pack(-side => 'left', -fill => 'both', -expand => '1');
			}
			$co_w[$co_max] = $mw->Label(-text => ' ')->pack(-side => 'left');
			$co_max++;
		$mw->update;
		}
		&mess_print("$V2_mess_3");
	}
	else {
		alert("$V2_mess_4");
	}

} # end customize_options


sub new_options_file {
	if ($file_ged) {
		$file_opt = $file_ged;
		$file_opt =~ s/^(.*?)\.ged$/$1\.opt/i;
		if ( -e "$file_opt" ) { alert("$file_opt $V2_mess_6") }
		else {
			open(OPT_OUT, ">$file_opt");
			if ( -e "default.opt" ) { open( OPT_IN, "default.opt" )  }
			elsif ( !open( OPT_IN, "def-$msg_lang.opt" ) ) { 
				die "\n*********************** def-$msg_lang.opt $V2_text_9 ***********************\n"; 
			}
			while (<OPT_IN>) { print OPT_OUT; } 
			close OPT_IN;
			close OPT_OUT;
		}
	}
	else {
		alert("$V2_mess_4");
	}
	my $message = $V2_text_4.$file_opt;
	&mess_print($message);
} # end new_options_file

sub help1 {

    my $ver_dialog =   $mw->Dialog(-title   => 'Gedail Version', 
                                -text    => "GEDAIL\n\nVersion $version $msg_lang", 
                                -buttons => ['OK'], 
                                -bitmap  => 'info');
	$ver_dialog->Show;						
	$ver_dialog->focus;						

} # end help1

sub help2 {

    my $about_dialog = $mw->Dialog(-title   => "$V2_text_1", 
                                -text    => "$V2_about", 
                                -buttons => ['OK']); 
	$about_dialog->Show;						
	$about_dialog->focus;
	
} # end help2

sub select_options { 
	my $n = shift;
	$opt_window[$n] = $mw->Toplevel(-title   => "$cat_lib[$n]", -bg =>'white');
	$opt_window[$n]->Icon(-image => $xpm);       # full color icon picture 
    my $c8 = $opt_window[$n]->fontCreate(-family => "courier", -size => 8);
    my $c8b = $opt_window[$n]->fontCreate(-family => "courier", -size => 8, -weight => "bold");
 	my $edit_img = $opt_window[$n]->Photo(-file => "edit.gif", -format => 'gif'); my $edit_n = 0;
 	my $disk_img = $opt_window[$n]->Photo(-file => "disk.gif", -format => 'gif'); 
	$errors = $opt_window[$n]->Label(-relief => 'flat', -background => 'white', -foreground => 'blue')->pack(-anchor => 'nw');
	my $dots = ' ......................................................................................................................';
	my @so_frame = '';
	for (my $i=0;$i<=$line_count;$i++) { 
		if ($line_cat[$i] == $n) { $line_save[$i] = $line_value[$i]; }	# sauve
		if (($line_cat[$i] == $n) and (!$line_zlen[$i])) {
			$so_frame[$j] = $opt_window[$n]->Frame(-bg =>'white')
			->pack(-anchor => 'nw');
			$so_frame[$j]->Checkbutton(-text => $line_lib[$i], -variable => \$line_value[$i], -onvalue => '1', -offvalue => '0', -font => $c8, -bg =>'white')
			->pack(-side => 'left', -anchor => 'nw', -expand => '1', -fill => 'x');
		}
		elsif (($line_cat[$i] == $n) and ($line_zlen[$i] =~ /\d+/)) {
			$so_frame[$j] = $opt_window[$n]->Frame(-bg =>'white')
			->pack(-anchor => 'nw');
			$libelle = substr($line_lib[$i].$dots,0,$cat_lmax[$n]);
			$error[$i] = $so_frame[$j]->Label(-text => ' ', -height => '1', -width => '1', -relief => 'flat', -background => 'white', -foreground => 'red')
			->pack(-side => 'left');
			$so_frame[$j]->Label(-text => $libelle, -font => $c8, -bg =>'white')
			->pack(-side => 'left', -fill => 'x');
			$so_frame[$j]->Entry(-width => $line_zlen[$i], -textvariable => \$line_value[$i], -bg =>'#FEFFCF')
			->pack(-side => 'left', -padx => '10', -anchor => 'nw', -expand => '1');
		}
		elsif (($line_cat[$i] == $n) and ($line_zlen[$i] eq 'lang')) { # lang
			$so_frame[$j] = $opt_window[$n]->Frame(-bg =>'white')
			->pack(-anchor => 'nw');
			$so_frame[$j]->Label(-text => '  Languages :', -font => $c8, -bg =>'white')
			->pack(-side => 'left' );
			for (my $k=0;$k<$lang_count;$k++) {
				$so_frame[$j]->Checkbutton(-text => $lang_tab[$k], -variable => \$lang_sel[$k], -onvalue => '1', -offvalue => '0', -font => $c8, -bg =>'white')
				->pack(-side => 'left', -anchor => 'nw', -padx => '5');
			}
		}
		elsif (($line_cat[$i] == $n) and ($line_zlen[$i] eq 'text')) { # texte
			$so_frame[$j] = $opt_window[$n]->Frame(-bg =>'white')
			->pack(-anchor => 'nw');
			$so_frame[$j]->Button(-image => $edit_img, -command => [\&text_edit, $i])
			->pack(-side => 'left'); 
			$so_frame[$j]->Label(-text => $line_lib[$i], -font => $c8, -bg =>'white')
			->pack(-side => 'left', -fill => 'x');
		}
		elsif (($line_cat[$i] == $n) and ($line_zlen[$i] eq 'dir')) { # directory
			$so_frame[$j] = $opt_window[$n]->Frame(-bg =>'white')->pack(-anchor => 'nw');
			$so_frame[$j]->Button(-image => $disk_img, -command => [\&browse_dir, $i])
			->pack(-side => 'left', -expand => '1'); 
			$libelle = $line_lib[$i]; $libelle =~ s/^(.*?)\s*$/$1 /;
			$so_frame[$j]->Label(-text => $libelle, -font => $c8, -bg =>'white')
			->pack(-side => 'left', -fill => 'x');
			$so_frame[$j]->Entry(-width => $line_zform[$i], -textvariable => \$line_value[$i], -bg =>'#FEFFCF')
			->pack(-side => 'left', -padx => '10', -anchor => 'nw');
		}
		else { next; }

		$bulle[$j] = $opt_window[$n] -> Balloon ( ) ;
		$bulle[$j] -> attach ( $so_frame[$j], 
								-balloonmsg => $hlp_line{$line_var[$i]}, 
								-statusbar => $errors, 
								-statusmsg => "option $line_var[$i]", 
								-state => 'both',
								-initwait => '150') ;

		$j++;
	}

	my $trailer = $opt_window[$n]->Frame(-width => '50', -bg =>'white')->pack;
	$trailer->Button(-text => "$V2_acts_3", -command => sub { $ret = &save_options($n); if (!$ret) {$opt_window[$n]->destroy;}  else {$opt_window[$n]->update;} })
		->pack(-side => 'left', -padx => "10", -pady => '10');
	$trailer->Button(-text => "$V2_acts_2", -command => sub { &restore_options($n); $opt_window[$n]->destroy })->pack(-side => 'left', -padx => '10');
	$opt_window[$n]->focus;						
} # end select_options 

sub go_gedail {
	if ($file_ged) {
		my $file = shift; my $ret =0; my $duration =0; 
		if ($file_opt !~ /^.:[!@#$%^&()_-{}`\'\\\/\sa-zA-Z0-9]*\.opt$/i) { $file_opt = &dos_name($file_opt); }
		($ret,$duration,$out_dir) = &gedail_main($$file,$file_opt);
		my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($duration);
		if ($^O eq 'MSWin32') { $out_dir =~ s/\//\\/g; }
		&mess_print("$min min $sec sec : $ret $V2_text_8 $out_dir ");
		my $page_url = $file_pref."_ind.html";
		if ($^O eq 'MSWin32') { system 'shellexecute.exe',"/f:\"$out_dir\\$page_url\"";}
		else { $page_url = "$out_dir\\$page_url"; $page_url =~ s/\\/\//g ; display(file => $page_url); }
		}
	else {
		alert("$V2_mess_4");
	}
} # end go_gedail

sub browse_file {
	my $filetypes = [['Gedcom', '.ged'],['All Files', '*']];
	my $filename = $mw->getOpenFile(-filetypes=> $filetypes, -defaultextension => '.ged', -initialfile => $file_save[0], -title => "$V2_text_3");
	if ($filename) {
		if ($filename !~ m/\.ged$/i) {
			alert("$V2_mess_5");
		}
	}
	if ($filename !~ /^.:[!@#$%^&()_-{}`\'\\\/\sa-zA-Z0-9]*\.ged$/i) { $filename = &dos_name($filename); }
	return($filename);
} # end browse_file

sub browse_dir {
	my $n = shift;
	my ($dirtree, $sel_dir, $init_dir);
	if ($line_value[$n] !~ /^\s*$/) { $init_dir = $line_value[$n]; } else { $init_dir = $ged_dir; }
	my $top_dir=$opt_window[$line_cat[$n]]->Toplevel(-title=> $line_lib[$n] );
	   $sel_dir=$top_dir->Entry(-text=> $line_value[$n])->pack(-side=> 'top', -fill=> 'x', -expand=> 1);
	   $dirtree=$top_dir->Scrolled('DirTree', -scrollbars=> 'osoe', -height=> 15, -width=> 80, -background=> 'white', -directory=> $init_dir, -selectmode=> 'single', -browsecmd=> sub {if ($dirtree->selectionGet()) {$sel_dir->delete(0,'end'); $sel_dir->insert(0, $dirtree->selectionGet); $top_dir->update;}})->pack(-side=> 'top', -fill=> 'x', -expand=> 1);
#	if ($^O eq 'MSWin32') {
# 		require Win32API::File;
# 		my @drv = map{s/\\$//;lc} Win32API::File::getLogicalDrives();
#		if ($drv[0] =~ /a:/i) { shift @drv; }
#		if ($drv[0] =~ /b:/i) { shift @drv; }
#		$dirtree->add_to_tree($_, $_) for @drv;
#	}
	if ($init_dir =~ /c:/i) { $drv[0] = 'C:'; $dirtree->add_to_tree($_, $_) for @drv; }
	my $trailer = $top_dir->Frame()->pack;
	$trailer->Button(-text=> $V2_acts_3, -command=> sub { $line_value[$n]=$sel_dir->get; $top_dir->destroy(); })
	->pack(-side=> 'left', -padx => '10', -pady => '5');
	$trailer->Button(-text=> $V2_acts_2, -command=> sub { $top_dir->destroy(); })
	->pack(-side => 'left', -padx => '10');
} # end browse_dir

sub text_edit {
	my $n = shift;
	my $rows = 10; my $cols =80;  # default
	if ($line_zform[$n] =~ /^(\d{1,3})x(\d{1,3})\s*$/i) { $rows = $1; $cols = $2; }
	my $edit_window = $opt_window[$line_cat[$n]]->Toplevel(-title   => "edit $line_var[$n] : $line_lib[$n]");
	my $edit_area = $edit_window->Scrolled ('Text' , -scrollbars => 'se' ,
		-height => $rows, -width => $cols, -relief => 'groove', -bg =>'#FEFFCF')->pack;
	my $text = $line_value[$n];
	$text =~ s/\\n/\n/g;
	$text =~ s/\\'/'/g;
	$edit_area -> insert ( 'end' , $text );
	$text_width = $cols;
	my $just_frame = $edit_window->Frame(-bg =>'white')
	->pack(-anchor => 'nw');
	$just_frame->Label(-text => $V2_text_10, -background => 'white')
	->pack( -side => 'left', -padx => '5');
	$just_frame->Entry(-width => '3', -textvariable => \$text_width, -bg =>'#FEFFCF')
	->pack(-side => 'left', -anchor => 'nw');
	$just_frame->Label(-text => $V2_text_11, -bg =>'white')
	->pack(-side => 'left', -padx => '5', -fill => 'both', -expand => '1');
	my $trailer = $edit_window->Frame(-width => '50')->pack;
	$trailer->Button(-text => "$V2_acts_3", -command => sub { $line_value[$n] = $edit_area -> get ( '1.0' , 'end' ); &text_save($n); $edit_window->destroy; })
	->pack(-side => 'left', -padx => '10', -pady => '5');
	$trailer->Button(-text => "$V2_acts_2", -command => sub { $line_value[$n] = $line_save[$n]; $edit_window->destroy; })
	->pack(-side => 'left', -padx => '10');
	$edit_area->focus;
	return;
} # end text_edit

sub text_save {
	my $n = shift;
	my $save = $/; $/ = ""; chomp($line_value[$n]); $/ = $save; # chomp all new lines in paragraph mode 
	$line_value[$n] = text_justify($line_value[$n],$text_width);
	$line_value[$n] =~ s/\n/\\n/g;
	$line_value[$n] =~ s/'/\\'/g;
	$line_save[$n] = $line_value[$n];
	$text_width = 0;
} # end text_save

sub text_justify {
	my $text= shift;
	my $width= shift;
	if ($width and $width =~ /^\d{1,3}$/ and (length($text) > $width)) {
		my @parts = split(/\n/,$text);		
		$text = ''; my ($deb,$fin) = ''; 
		for (my $i=0;$i<@parts;$i++) { 
			$deb = $parts[$i]; $fin = ''; 
			while (length($deb) >= $width) { 
				$deb =~ /^(.{$width})(.*)$/; 
				$deb = $1; $fin = $2;
				if ($deb =~ /^(.*?)\s(\S*)$/) {
					$text .= $1." \n";
					$deb = $2.$fin;
				}
				else { $text .= $deb; $deb = $fin; } # no space
			}
			$text .= $deb;
			if ($i<@parts-1) { $text .= "\n"; }
		}
	}
	return($text);
} # end text_justify

sub alert {
	my $message = $_[0];
	my $alert=$mw->messageBox(-type=>'OK', -title=>'Alert', -message=> $message);
} # end alert

sub find_options {
	$file_ged =~ /^(.*?)((\w|~)*)\.ged$/i;
	$ged_dir = $1;
	my $ret = &ana_ged(); if ($ret) { return($ret) };
	$file_opt = $file_ged;
	$file_opt =~ s/^(.*?)\.ged$/$1\.opt/i;
	if ( -e "$file_opt" ) { }
	elsif ( -e "default.opt" ) { $file_opt = 'default.opt'; }
	else { die "\n*********************** default.opt $V2_text_9 ***********************\n"; }
	&set_options;
	my $message = $V2_text_4.$file_opt;
	&mess_print($message);
} # end find_options

sub set_options {
	if ( open( OPTIONS, "def-$msg_lang.opt" ) ) {
		my $i = 0;
		my $categ = 0;
		my $icon = '';
		my $lib = '';
		my $last_var = '';
		while (my $line = <OPTIONS>) {
			if ($line =~ /^\s*###\s+(.*?)\s*##\s*(.*?)\s*$/) {
				$lib = $1; 
				$icon = $2; 
				if ($icon eq '!!!') { $categ = 0; } # Expert options 
				else { 
					$categ++;
					$cat_count = $categ;
					$cat_lib[$categ] = $lib; 
					$cat_icon[$categ] = $icon; 
				}
				$line_comm[$i] = "### ".$lib;
			}
			elsif ($line =~ /^\s*([$|@][^=]*?)\s*=\s*([\'\"\(]?)(.*?)([\'\"\)]?)\s*;\s*(#.*)$/) {
				$line_cat[$i] = $categ;
				$line_var[$i] = $1;
				$line_q1[$i] = $2;
				$line_def[$i] = $3;
				$line_q2[$i] = $4;
				$line_comm[$i] = $5;
				$last_var = $line_var[$i];
				$hlp_line{$last_var} = '';
				$opt_line{$line_var[$i]} = $i;
				$line_comm[$i] =~ /^#\s*([^#]+?)\s*(#[^#]+)?(##([^#]+))?(##([^#]+?))?\s*$/;
				$line_lib[$i] = $1;
				$line_comm[$i] = "# ".$1." ".$2;
				$line_zlen[$i] = $4;
				$line_zform[$i] = $6;
				if (length($line_lib[$i]) > $cat_lmax[$categ]) { $cat_lmax[$categ] = length($line_lib[$i]) }
				my $var_len = length($line_var[$i])+length($line_q1[$i])+length($line_def[$i])+length($line_q2[$i])+4;
				if ($var_len > $var_max) { $var_max = $var_len; }
				if ($line_zlen[$i] eq 'lang') { # lang
					$lang_line = $i;
					@lang_tab = split(/,/,$line_zform[$i]);		# Init table with multi lang
					$lang_count = @lang_tab;					# number of Langs
				}
			}
			elsif ($last_var and $line =~ /^\s*#\.(.*?)\s*#*$/) {
				if ($hlp_line{$last_var}) { $hlp_line{$last_var} .= "\n".$1; }
				else { $hlp_line{$last_var} .= $1; }
				chomp($line_comm[$i] = $line);
				$line_comm[$i] =~ s/#\./#/;
			}
			else {
				chomp($line_comm[$i] = $line);
			}
			$i++;
		}
		$line_count = $i;
		close OPTIONS ;
	}
	else { die "\n*********************** def-$msg_lang.opt $V2_text_9 ***********************\n"; }
	&restore_default();
	if ( open( OPTIONS, $file_opt ) ) {
		while (my $line = <OPTIONS>) {
			if ($line =~ /^\s*([$|@][^=]*?)\s*=\s*([\'\"\(]?)(.*?)([\'\"\)]?)\s*;\s*(#.*)$/) {
				if ($opt_line{$1}) { $line_value[$opt_line{$1}] = $3; }
			}
		}
		for ($k=0;$k<$lang_count;$k++) {
			if ($line_value[$lang_line] =~ /$lang_tab[$k]/i) { $lang_sel[$k] = 1; }
			else { $lang_sel[$k] = 0; }
		}
		close OPTIONS ;
	}
# dfaut si omis
	if ($opt_line{'$aut_name'} and $line_value[$opt_line{'$aut_name'}] eq '') { $line_value[$opt_line{'$aut_name'}] = $ged_aut; }
	if ($opt_line{'$aut_addr1'} and $line_value[$opt_line{'$aut_addr1'}] eq '') { $line_value[$opt_line{'$aut_addr1'}] = $ged_addr1; }
	if ($opt_line{'$aut_addr2'} and $line_value[$opt_line{'$aut_addr2'}] eq '') { $line_value[$opt_line{'$aut_addr2'}] = $ged_addr2; }
	if ($opt_line{'$aut_addr3'} and $line_value[$opt_line{'$aut_addr3'}] eq '') { $line_value[$opt_line{'$aut_addr3'}] = $ged_addr3; }
	if ($opt_line{'$aut_addr4'} and $line_value[$opt_line{'$aut_addr4'}] eq '') { $line_value[$opt_line{'$aut_addr4'}] = $ged_addr4; }
	if ($opt_line{'$aut_ctry'} and $line_value[$opt_line{'$aut_ctry'}] eq '') { $line_value[$opt_line{'$aut_ctry'}] = $ged_ctry; }
	if ($opt_line{'$aut_phone'} and $line_value[$opt_line{'$aut_phone'}] eq '') { $line_value[$opt_line{'$aut_phone'}] = $ged_phone; }
	if ($opt_line{'$aut_email'} and $line_value[$opt_line{'$aut_email'}] eq '') { $line_value[$opt_line{'$aut_email'}] = $ged_email; }
# impos par le fichier
	if ($opt_line{'$place_format'} and $ged_format) { $line_value[$opt_line{'$place_format'}] = $ged_format; }
	if ($opt_line{'$charset'} and $ged_char) { $line_value[$opt_line{'$charset'}] = $ged_char; }
# paramtres pour Gedpics
	if ($opt_line{'$out_dir'}) { $out_dir = $line_value[$opt_line{'$out_dir'}]; }
	if ($opt_line{'$file_pref'}) { $file_pref = $line_value[$opt_line{'$file_pref'}]; if (!$file_pref) { $file_pref = 'Gedi'; } }
	if ($opt_line{'$photo_gallery'}) { $photo_gallery = $line_value[$opt_line{'$photo_gallery'}]; }
	if ($opt_line{'$photo_max_size'}) { $photo_max_size = $line_value[$opt_line{'$photo_max_size'}]; }
	if ($opt_line{'$photo_thumb_size'}) { $photo_thumb_size = $line_value[$opt_line{'$photo_thumb_size'}]; }
	if ($opt_line{'$css_style'}) { $css_style = $line_value[$opt_line{'$css_style'}]; }
} # end set_options

sub save_options {
	my $categ = shift;
	my $i = 0;
	my $error_mess = '';
	if ($categ) {
		my $error_count = 0;
		for ($i=0;$i<=$line_count;$i++) {
			if (($line_cat[$i] == $categ) and ($line_zlen[$i] =~ /\d+/)) { 
				if ($line_value[$i] !~ /^$line_zform[$i]$/i) { 
					$error[$i]->configure(-text => '!', -background => 'red', -foreground => 'white' );
					$error_count++;
				}	
				else { $error[$i]->configure(-text => ' ', -foreground => 'red' ); }
			}
		}
		if ($error_count) {	 
			$error_mess	= '!  '.$error_count.$V2_text_5;
			$errors->configure(-text => $error_mess, -foreground => 'red' );
			return($error_count);
		}
		else { $error_mess	= ' '; $errors->configure(-text => $error_mess, -background => 'white', -foreground => 'blue'); } 
				
	}
	open(OPT_FILE, ">$file_opt");
	my $ilang = 0;
	for (my $k=0;$k<$lang_count;$k++) {
		if ($lang_sel[$k] and !$ilang) { $line_value[$lang_line] = $lang_tab[$k]; $ilang = 1; }
		elsif ($lang_sel[$k] and $ilang) { $line_value[$lang_line] .= ','.$lang_tab[$k]; }
	}
	for ($i=0;$i<=$line_count;$i++) {
		my $padd_len = $var_max-length($line_var[$i])-length($line_q1[$i])-length($line_value[$i])-length($line_q2[$i])-3;
		my $var_padd = substr('                                                     ',0,$padd_len);             
		if ($line_var[$i] =~ /^[$|@]/) { print OPT_FILE "$line_var[$i] = $line_q1[$i]$line_value[$i]$line_q2[$i];$var_padd$line_comm[$i]\n"; }
		else { print OPT_FILE "$line_comm[$i]\n"; }
	}
	close OPT_FILE;
# paramtres pour Gedpics
	if ($opt_line{'$file_pref'}) { $file_pref = $line_value[$opt_line{'$file_pref'}]; if (!$file_pref) { $file_pref = 'Gedi'; } }
	if ($opt_line{'$out_dir'}) { $out_dir = $line_value[$opt_line{'$out_dir'}]; }
	if ($opt_line{'$photo_max_size'}) { $photo_max_size = $line_value[$opt_line{'$photo_max_size'}]; }
	if ($opt_line{'$photo_thumb_size'}) { $photo_thumb_size = $line_value[$opt_line{'$photo_thumb_size'}]; }
	if ($opt_line{'$photo_gallery'}) { $photo_gallery = $line_value[$opt_line{'$photo_gallery'}]; }
	if ($opt_line{'$css_style'}) { $css_style = $line_value[$opt_line{'$css_style'}]; }
	my $message = $V2_text_4.$file_opt.$V2_text_6;
	&mess_print($message);
	return;
} # end save_options

sub restore_options {
	my $categ = shift;
	for (my $i=0;$i<=$line_count;$i++) {
		if ($line_cat[$i] == $categ) { $line_value[$i] = $line_save[$i]; }	# restore
	}
	if ($line_cat[$lang_line] == $categ) { 
		for (my $k=0;$k<$lang_count;$k++) {
			if ($line_value[$lang_line] =~ /$lang_tab[$k]/i) { $lang_sel[$k] = 1; }
			else { $lang_sel[$k] = 0; }
		}
	}
} # end restore_options

sub restore_default {
	for (my $i=0;$i<=$line_count;$i++) {
		if ($line_var[$i]) {  $line_value[$i] = $line_def[$i] }
	}
	for (my $k=0;$k<$lang_count;$k++) {
		if ($line_value[$lang_line] =~ /$lang_tab[$k]/i) { $lang_sel[$k] = 1; }
		else { $lang_sel[$k] = 0; }
	}
} # end restore_default

sub ana_ged {
	($ged_date,$ged_format,$ged_char,$ged_aut,$ged_addr1,$ged_addr2,$ged_addr3,$ged_addr4,$ged_ctry,$ged_phone,$ged_email) = '';
	&init_var();
	$n_indi=0; $n_fam=0; $n_obje=0; $n_note=0; $n_sour=0; $n_even=0; $n_note2=0; $n_sour2=0; $n_obje2=0;
	my ($in0,$in1,$subm_id,$subm_rec,$form,)=''; my $addr_cont=0;  
	my $events_list = 'ADOP|ADPF|ADPM|AFN|ASSO|BAPL|BAPM|BARM|BASM|BLES|BRTM|BURI|CAST|CAUS|CENS|CHR|CHRA|CONF|CONL|CREM|EDUC|EMIG|ENDL|FCOM|FNRL|GRAD|IDNO|IMMI|INTE|MILI|NATI|NATU|NCHI|NLIV|NMAR|NMR|ORDI|ORDN|PROB|PROP|RELI|RESI|RETI|RFN|SLGC|SLGS|SSN|WILL|YART|ANUL|DIV|DIVF|ENGA|MARB|MARC|MARL|MARS|MBON|SEPR|OCCU|TITL|EVEN';
	my ($number,$ana,$lib) = ''; 
	my $save_nl = $/;  my $ged_file_nl = $/; # save new_line separator
	open( INPUT, "< $file_ged" ) or die "\nCouldn't open gedcom file $file_ged\n";
	binmode INPUT or die "($!,$^E)";
  defined( my $r = sysread( INPUT, $head, 20 ) ) or die "\nCouldn't read gedcom file $file_ged\n";
	close INPUT;
	if ($head =~ /^0 HEAD\x20*\r\d/is) { $ged_file_nl = "\r"; print "newline is carriage return\n"; } # \r single carriage return as end-of-line
	$/ = $ged_file_nl; 
	if ( open( GED_FILE, "$file_ged" ) ) {
		while (<GED_FILE>) {
		   if (/^\s*0\s*(.*)$/) {                                                                                              
			   $rol = $1;
			   if ($rol =~ /HEAD/) { $in0 = 1; }  # header
			   elsif ($rol =~ /@(.*?)@\sSUBM/) { $subm_rec = $1; $in0 = 2;}         # submission record
			   elsif ($rol =~ /@(.*?)@\sINDI/) { $n_indi++; $in0 = 0; $ref = $1;}  
			   elsif ($rol =~ /@(.*?)@\sFAM/) { $n_fam++; $in0 = 0; $ref = $1;}  
			   elsif ($rol =~ /@(.*?)@\sOBJE/) { $n_obje++; $in0 = 3; $ref = $1;}  
			   elsif ($rol =~ /OBJE/) { $n_obje++; $in0 = 3;}  
			   elsif ($rol =~ /NOTE/) { $n_note++; $in0 = 0;}  
			   elsif ($rol =~ /SOUR/) { $n_sour++; $in0 = 0;}
		   }
		   elsif (/^\s*1\s*(.*)$/) {
			   $rol = $1; $in1 = '';
			   if ($in0 eq 1) { 
				   if ( $rol =~ /^CHAR\s+(.*)$/ ) { $ged_char = uc($1); }
				   elsif ( $rol =~ /^DATE\s+(.*)$/ ) { $ged_date = $1;  }
				   elsif ( $rol =~ /^PLAC\s+(.*)$/ ) { $in1 = 'PLAC'; }
				   elsif ( $rol =~ /^SUBM\s+@(.*?)@/ ) { $subm_id = $1; }
			   }
			   elsif ($in0 eq 2 and $subm_id eq $subm_rec) { 
				   if ( $rol =~ /^ADDR\s*(.*)$/ ) { $ged_addr1 = $1; $addr_cont = 1;}
				   elsif ( $rol =~ /^NAME\s+(.*)$/ ) { $ged_aut = $1; }
				   elsif ( $rol =~ /^CTRY\s+(.*)$/ ) { $ged_ctry = $1; }
				   elsif ( $rol =~ /^PHON\s+(.*)$/ ) { $ged_phone = $1; }
				   elsif ( $rol =~ /^_+EMAIL\s+(.*)$/i ) { $ged_email = $1; }
			   }
			   elsif ( $in0 == 3 ) {						# obje record
				   $in0 = $in0*&pics_vali($rol);
			   }
			   else { $addr_cont = 0;
				   if ( $rol =~ /^NOTE\s+[^@].*/ ) { $n_note++; }
				   elsif ( $rol =~ /^SOUR\s*[^@].*/ ) { $n_sour++; }
				   elsif ( $rol =~ /^OBJE\s*[^@].*/ ) { $n_obje++; $in1 = 'OBJE'; }
				   elsif ( $rol =~ /^($events_list)/ ) { $n_even++; }
			   }
		   }
		   elsif (/^\s*2\s*(.*)$/) {
			   $rol = $1;
			   if ($in0 eq 2 and $subm_id eq $subm_rec and $addr_cont and  $rol =~ /^CONT\s*(.*)$/ ) {                                                                          
				   if    ( $addr_cont == 1 ) { $ged_addr2 = $1; $addr_cont = 2; }
				   elsif ( $addr_cont == 2 ) { $ged_addr3 = $1; $addr_cont = 3; }
				   elsif ( $addr_cont == 3 ) { $ged_addr4 = $1; $addr_cont = 0; }
			   }
			   elsif ( $in1 eq 'PLAC' and $rol =~ /^FORM\s(.*)$/ ) {    # PLAC FORM record
				   # 1 PLAC
				   # 2 FORM Town , Area code , County , Region , Country, Subdivision
				   $form = $1; 
				   $ged_format = $form; 
				   $ged_format =~ s/Subdivision/1/i;
				   $ged_format =~ s/Town/2/i;
				   $ged_format =~ s/Area code/3/i;
				   $ged_format =~ s/County/4/i;
				   $ged_format =~ s/Region/5/i;
				   $ged_format =~ s/Country/6/i;
				   $ged_format =~ s/\s//g;
				   if ($ged_format !~ /^[123456\,\;]*$/) { $ged_format = '';  }
			   }
			   elsif ( $in1 eq 'OBJE' ) {    # PLAC FORM record
				   $rol = &pics_vali($rol);
				   if (!$rol) { $in1 = ''; }
			   }
			   elsif ( $rol =~ /^NOTE\s+[^@].*/ ) { $n_note2++; }
			   elsif ( $rol =~ /^SOUR\s+[^@].*/ ) { $n_sour2++; }
			   elsif ( $rol =~ /^OBJE\s+[^@].*/ ) { $n_obje2++; }
		   }
		}
		close GED_FILE ;
		$/ = $save_nl;
		if ( $ged_char and $ged_char ne "ANSI" ) { 
		   ($ged_aut,$ged_addr1,$ged_addr2,$ged_addr3,$ged_addr4,$ged_date,$ged_ctry) = &process_accents($ged_char,$ged_aut,$ged_addr1,$ged_addr2,$ged_addr3,$ged_addr4,$ged_date,$ged_ctry);
		}
		my $i = 0;
		if($ga_max) { 
			for ($i=0;$i<$ga_max;$i++) { $ga_w[$i]->destroy; } 
			$mw->update; 
			$ga_max =0; 
		}
		if($co_max) { 
			for ($i=0;$i<$co_max;$i++) { $co_w[$i]->destroy; } 
			$mw->update; 
			$co_max =0; 
		}
 		$ga_w[0] = $mw->Label(-text => ' ')->pack();
		$ga_w[1] = $mw->Frame(-relief => 'groove', -borderwidth => '2', -bg => 'white')->pack();
		$ga_frame_1g = $ga_w[1]->Frame(-bg => 'white')
		->pack(-side => 'left');
		$ga_frame_1r = $ga_w[1]->Frame(-relief => 'solid', -borderwidth => '1', -bg => '#FEFFCF')
		->pack(-side => 'right');
		foreach $ana (ged_date,ged_format,ged_char,ged_aut,ged_addr1,ged_addr2,ged_addr3,ged_addr4,ged_ctry,ged_phone,ged_email) {
			if ($$ana ne '') {
				$lib = "V2_".$ana; 
				$ga_frame_1g->Label(-text => $$lib, -font => $h12i, -bg => 'white')
				->pack(-fill => 'both', -anchor => 'ne', -padx => '5');
				$ga_frame_1r->Label(-text => $$ana, -font => $h12i, -bg => '#FEFFCF')
				->pack(-expand => '1', -anchor => 'nw', -padx => '5');
			}	
		}
 		$ga_w[2] = $mw->Label(-text => ' ')->pack();
		$ga_w[3] = $mw->Frame(-relief => 'groove', -borderwidth => '2', -bg => 'white')->pack();
		$ga_frame_2g = $ga_w[3]->Frame(-bg => 'white')
		->pack(-side => 'left');
		$ga_frame_2r = $ga_w[3]->Frame(-relief => 'solid', -borderwidth => '1', -bg => '#FEFFCF')
		->pack(-side => 'right');
		foreach $number (n_indi,n_fam,n_note,n_sour,n_obje,n_even,n_note2,n_sour2,n_obje2) { 
			$lib = "V2_".$number; 
			$ga_frame_2g->Label(-text => $$lib, -font => $h12i, -bg => 'white')
			->pack(-fill => 'both', -anchor => 'ne', -padx => '5');
			$ga_frame_2r->Label(-text => $$number, -font => $h12i, -width => '5', -bg => '#FEFFCF')
			->pack(-expand => '1', -anchor => 'nw');
		}
 		$ga_w[4] = $mw->Label(-text => ' ')->pack();
		$ga_max = 5;
		$mw->update;
		return(0);
	}
	else { alert("$file_ged $V2_mess_7"); return(1)}
} # end ana_ged

sub display_html {
### URL Encode and Decode
# $str =~ s/([^A-Za-z0-9])/sprintf("%%%02X", ord($1))/seg;
# $str can now be passed in the query string safely, for example:
# <a ref="page_launch.php?url=$str">LINK</a> 
# Likely, "page_launch.php" will want to decode $str back into something useful:
# $str =~ s/\%([A-Fa-f0-9]{2})/pack('C', hex($1))/seg;
###
	my $page = shift;
	my $html = "http://$page";
	if ($^O eq 'MSWin32') { 
		system("start iexplore.exe $html");
	}
	else {
		$html = "<HTML><BODY><A href=\"$html\">$V2_help_3..</a></BODY></HTML>";
		display(html => $html);
	}
} # end display_html

sub display_file {
	my $page = shift;
#	print "display_file $page<<\n";
	if ($^O eq 'MSWin32') { system 'shellexecute.exe',"/f:$page"; }
	else { $page =~ s/\\/\//g; display(file => $page); 	}
} # end display_file

sub pics_vali {
	my $rol = shift;
	my $ret = 1;
	if ( $rol =~ /FORM\s+(.*)/ ) {	
		if ( $1 !~ /(GIF|JPG|BMP|PNG|JPEG)/i ) { $ret = 0; }
		else { $i_pics++; }
	}
	if ($rol =~ /FILE\s+(.*)/) {
		$pics_file[$i_pics-1] = $1;
		if ( $ged_char and $ged_char ne "ANSI" ) { $pics_file[$i_pics-1] = &process_accents($ged_char,$pics_file[$i_pics-1]); }
		if ($pics_file[$i_pics-1] !~ /^(.*(\\|\/))([^\\\/]*?)\.(\w*)$/) {
			$pics_file[$i_pics-1] = $ged_dir.$pics_file[$i_pics-1]; 
		}
		$pics_file[$i_pics-1] =~ s/\//\\/g;
		$pics_ref[$i_pics-1] = $ref;
	}
	if ($rol =~ /TITL\s+(.*)/) {
		$pics_title[$i_pics-1] = $1;
		if ( $ged_char and $ged_char ne "ANSI" ) { $pics_title[$i_pics-1] = &process_accents($ged_char,$pics_title[$i_pics-1]); }
	}
	return($ret);
} # end pics_vali

sub pics_generate {
	my $pics_count = 0;
	if ($photo_gallery =~ /^([1-9]\d*)x([1-9]\d*)$/ ) { $gall_cols = $1; $gall_rows = $2; }
	else { $gall_cols = 10; $gall_rows = 5; }
	if ($file_ged) {
		my $page_count = 0;
		if ( !$file_pref ) { $file_pref = 'Gedi'; }
		if ( !$out_dir ) { $out_dir = $ged_dir . "$file_pref"; }
		elsif ( $out_dir =~ /^(\.\/|\.\\|\/|\\)(.*?)[\/\\]+$/ ) { $out_dir = $ged_dir.$2; }
		elsif ( $out_dir =~ /^(\.\/|\.\\|\/|\\)(.*?[^\/\\])$/ ) { $out_dir = $ged_dir.$2; }
		elsif ( $out_dir =~ /^([^\/\\]*)$/ ) { $out_dir = $ged_dir . $1; }
		elsif ( $out_dir =~ /^(\.\.\/|\.\.\\)(.*)$/ ) { die "Couldn't create $out_dir directory\n"; }
		$out_dir =~s/\//\\/g;
		if ( !-e $out_dir ) {				# Make the directory 
			unless ( mkdir( $out_dir, 0755 ) ) {
				die "Couldn't create $out_dir directory\n";
			}
		}
		$pics_dir = "$out_dir\\photos"; 
		$pics_dir =~s/\//\\/g;
		if ($pics_dir !~ /^.:[!@#$%^&()_\-{}`\\\sa-zA-Z0-9]*$/i) { $pics_dir = &dos_name($pics_dir); }
		if ( !-e $pics_dir ) {				# Make the directory
			unless ( mkdir( $pics_dir, 0755 ) ) {
				die "Couldn't create $pics_dir directory\n";
			}
		}
		&bincopy( "$install_dir/Gedail/Pics/next.gif", "$pics_dir/next.gif" );
		&bincopy( "$install_dir/Gedail/Pics/prev.gif", "$pics_dir/prev.gif" );
		&bincopy( "$install_dir/Gedail/Pics/back.gif", "$pics_dir/back.gif" );
		&bincopy( "$install_dir/Gedail/Pics/photo.jvs", "$pics_dir/photo.jvs" );
		$file_first = $file_pref.'px00';
		my $cols_count = 0;
		my $rows_count = 0;
		my $file_curr = $file_first;
		my $file_next = $file_first;
		my $file_prev = $file_first;
		print "\n";
		unless ( open( LOG_FILE, ">$install_dir/Gedail/gedpics.log" ) ) {
			die "\nCouldn't open log file $install_dir/Gedail/gedpics.log\n";
		}
LOOP: for (my $i=0;$i<@pics_file ;$i++) {
			$pics_file[$i] =~ /^(.*)\\([^\\]+?)\.([^\.]+?)$/;
			my $fpics_dir = $1;
			my $fpics_in = $2.'.'.$3;
			my $fpics_typ = $3;
			my $fpics_out = $2;
			if (!$pics_title[$i]) { $pics_title[$i] = $fpics_out; }
			$pics_title[$i] =~ s/\'/ /g;
			if (($fpics_dir !~ /^.:[!@#$%^&()_\-{}`\\\sa-zA-Z0-9]*$/i) or ($fpics_in !~ /^[!@#$%^&()_\-{}`\sa-zA-Z0-9]*\.[^\.]+?$/i)) { 
				$fpics_in = $install_dir."\\Gedpics\\picstemp.".$fpics_typ; 
				my $rc = bincopy($pics_file[$i],$fpics_in);
				if (!$rc) { 
					print "\n$pics_ref[$i]-$pics_file[$i] doesn't exist\n"; 
					print LOG_FILE "$pics_ref[$i]-$pics_file[$i] doesn't exist\n";
					next LOOP; 
				}
			}
			else { $fpics_in = $fpics_dir."\\".$fpics_in; }
			if ($fpics_out !~ /^[!@#$%^&()_\-{}`\sa-zA-Z0-9]*$/i) { 
				$fpics_out =~ tr/\*\+\|\=\?\[\]\.\;\:\'\"\<\>/AAAAAACEEEEIIIINOOOOOUUUUYaaaaaaceeeeiiiinooooouuuuyy______________/;
			}
			$fpics_out = $fpics_out.'.jpg';
			if ( -e "$fpics_in" ) { 
				system "$install_dir\\Gedpics\\VisualMagick\\bin\\convert.exe","\"$fpics_in\" -resize $photo_max_size\">\" +profile \"*\" \"$pics_dir\\gi_$fpics_out\"";
				system "$install_dir\\Gedpics\\VisualMagick\\bin\\convert.exe","\"$fpics_in\" -resize $photo_thumb_size\">\" -compress JPEG \"$pics_dir\\tn_$fpics_out\"";
				print ".";
				print LOG_FILE "$pics_ref[$i]-$pics_file[$i]-$pics_title[$i] processed\n";
				if ( $photo_gallery and ($photo_gallery ne '0x0')) { 
					if ($rows_count < 1 ) {
						if ($pics_count) {
							$file_next++;
							&gallery_trailer($file_next,$file_prev); 
							close OUT_PAGE ;
							if ($file_curr ne $file_first) { $file_prev++; }
							$file_curr++;
						}
						$rows_count = $gall_rows;
						unless ( open( OUT_PAGE, ">$pics_dir/$file_curr.html" ) ) {
							die "\nCouldn't open gallery file $file_curr.html\n";
						}
						$rows_count = $gall_rows;
						$cols_count = $gall_cols;
						&gallery_header;
					}                    
					my ( $x, $y ) = pics_size("$pics_dir/gi_$fpics_out");
					print OUT_PAGE "<TD><A HREF=\"javascript:photo('gi_$fpics_out', '$pics_title[$i]', '$x', '$y')\">"; 
					print OUT_PAGE "<IMG SRC=\"tn_$fpics_out\" TITLE=\"$pics_title[$i]\" BORDER=0><\/A><BR><FONT SIZE=-2><A HREF=\"javascript:pics_links('$pics_ref[$i]')\">$pics_ref[$i]</A></FONT><\/TD>\n"; 
					$cols_count--;
					if ($cols_count < 1 ) {
						print OUT_PAGE '</TR><TR ALIGN=CENTER VALIGN=CENTER>'."\n";
						$cols_count = $gall_cols;
						$rows_count--;
					}
				}
				$pics_count++;
			}
			else { 
				print "\n$pics_ref[$i]-$pics_file[$i] doesn't exist\n";
				print LOG_FILE "$pics_ref[$i]-$pics_file[$i] doesn't exist\n";
			}
		}
		if ($pics_count) {
			if ( $photo_gallery and ($photo_gallery ne '0x0')) { 
				&gallery_trailer($file_first,$file_prev);
				close OUT_PAGE ;
				unless ( open( OUT_PAGE, ">$install_dir/Gedpics/gedpicst.html" ) ) {
					die "\nCouldn't open results file $install_dir/Gedpics/gedpicst.html\n";
				}
				my $page_url = "file://$pics_dir/$file_first.html";
				$page_url =~s/\\/\//g;
				print OUT_PAGE <<END
<HTML><HEAD><script language="javascript" TYPE="text/javascript">
<!-- 
function skip(page) { document.location.href=page; }
//-->
</script></HEAD><BODY onload="skip('$page_url')";></BODY></HTML>
END
;
				close OUT_PAGE ;
			}
			if ($^O eq 'MSWin32') { system 'shellexecute.exe',"/f:\"$pics_dir\\$file_first.html\""; }
			else { $page_url = "$pics_dir\\$file_first.html"; $page_url =~ s/\\/\//g ; display(file => $page_url); }
		}
		close LOG_FILE ;
		my $message = $pics_count.$V2_text_12;
		&mess_print($message);
	}
	else {
		alert("$V2_mess_4");
	}
} # end pics_generate

sub gallery_header {
 print OUT_PAGE <<END
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<HTML><HEAD>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<meta name="GENERATOR" content="Gedail V$version">
<meta name="AUTHOR"	content="J-F BAQUET">
<link rel="STYLESHEET" TYPE="text/css" HREF="../$css_style.css">
<script LANGUAGE="javascript" TYPE="text/javascript" SRC="photo.jvs"></script>
<script LANGUAGE="javascript" TYPE="text/javascript" SRC="pics_links.jvs"></script>
<TITLE>$V2_text_13</TITLE></HEAD>
<BODY><CENTER><br>&nbsp;<br>&nbsp;<br>
<TABLE CLASS="Block" BORDER=0 ALIGN=CENTER CELLPADDING=3 CELLSPACING=3><TR ALIGN=CENTER VALIGN=CENTER>
END
} # end gallery_header

sub gallery_trailer {
	my $next = shift;
	my $prev = shift;
	print OUT_PAGE <<END
</TR></TABLE>
<P></P><TABLE ALIGN=CENTER BORDER=0><TR>
<TD><A HREF="$prev.html"><IMG SRC="prev.gif" BORDER=0 ALT="&lt;&lt;"></A></TD>
<TD><A HREF="Javascript:self.close()" onMouseOver="window.status=''; return true"><IMG SRC="back.gif" BORDER=0 ALT="&lt;&gt;"></A></TD>
<TD><A HREF="$next.html"><IMG SRC="next.gif" BORDER=0 ALT="&gt;&gt;"></A></TD>
</TR></TABLE>
</CENTER></BODY></HTML>
END
} # end gallery_trailer

sub dos_name {
# -- convert long filenames to 8.3 restriction 
# These characters can appear in a DOS filename : ~ ! @ # $ % ^ & ( ) _ - { } `
# These characters cannot appear in a DOS filename : * / + | \ = ? [ ] ; : " . < > , spaces and accentued chars
	my $in =shift; my @items =(); my $out = ''; my $first =''; my $ext = 0; my $d = 0;
	$in =~s/\//\\/g;
	if ($in =~ /^(\.*|.:)\\(.*)$/) { $first = uc($1); $in = $2; }
	if ($in =~ /^(.*?)\.([^\.]*)$/) {  
		@items = split(/\\/,$1);
		$items[@items] = $2;
		$ext = 1;
	}
	else { @items = split(/\\/,$in); }
	for ( my $i = 0 ; $i < @items ; $i++ ) {
		my $l0 = length($items[$i]);
		$items[$i] =~ s/[^~!@#$%^&()_\-{}`\'a-zA-Z0-9]//g; 
		$items[$i]= uc($items[$i]); 
		my $l1 = length($items[$i]);
		if ( ($l0 > 8) or ($l1 < $l0)) {
			$items[$i] = substr($items[$i], 0, 6).'~1';
		}
	}
	if ($ext) { $items[@items-1] = substr($items[@items-1], 0, 3); } # ext
	if ($first) { $out = $first; } 
	else { $out = $items[0]; $d = 1;}
	for ( $i = $d ; $i < @items-$ext ; $i++ ) {
		$out .= '\\'.$items[$i];
	}
	if ($ext) { $out .= '.'.$items[@items-1]; }
	if ($in =~ /.*\\$/) { $out.='\\'; }
	return($out);
} # end dos_name

sub pics_size {
	my ($file) = @_;
	my ( $x, $y ) = ( 0, 0 );
	if ( defined($file) && open( STRM, "<$file" ) ) {
		binmode(STRM);				# for crappy MS OSes - Win/Dos/NT use is NOT SUPPORTED
		if ( $file =~ /\.jpe?g$/i )  { ( $x, $y ) = &jpegsize( \*STRM ); }
		else { print "$file is not .jpg (or has stupid name)"; }
		close STRM ;
	}
	return ( $x, $y );
}
